//
// event.hpp
// ~~~~~~~~~
//
// Copyright (c) 2003-2008 Christopher M. Kohlhoff (chris at kohlhoff dot com)
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//

#ifndef CPPCMS_BOOST_ASIO_DETAIL_EVENT_HPP
#define CPPCMS_BOOST_ASIO_DETAIL_EVENT_HPP

#if defined(_MSC_VER) && (_MSC_VER >= 1200)
# pragma once
#endif // defined(_MSC_VER) && (_MSC_VER >= 1200)

#include <cppcms_boost/asio/detail/push_options.hpp>

#include <cppcms_boost/asio/detail/push_options.hpp>
#include <cppcms_boost/config.hpp>
#include <cppcms_boost/asio/detail/pop_options.hpp>

#if !defined(CPPCMS_BOOST_HAS_THREADS)
# include <cppcms_boost/asio/detail/null_event.hpp>
#elif defined(CPPCMS_BOOST_WINDOWS)
# include <cppcms_boost/asio/detail/win_event.hpp>
#elif defined(CPPCMS_BOOST_HAS_PTHREADS)
# include <cppcms_boost/asio/detail/posix_event.hpp>
#else
# error Only Windows and POSIX are supported!
#endif

namespace cppcms_boost {
namespace asio {
namespace detail {

#if !defined(CPPCMS_BOOST_HAS_THREADS)
typedef null_event event;
#elif defined(CPPCMS_BOOST_WINDOWS)
typedef win_event event;
#elif defined(CPPCMS_BOOST_HAS_PTHREADS)
typedef posix_event event;
#endif

} // namespace detail
} // namespace asio
} // namespace boost

#include <cppcms_boost/asio/detail/pop_options.hpp>

#endif // BOOST_ASIO_DETAIL_EVENT_HPP
