//
// thread.hpp
// ~~~~~~~~~~
//
// Copyright (c) 2003-2008 Christopher M. Kohlhoff (chris at kohlhoff dot com)
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//

#ifndef CPPCMS_BOOST_ASIO_DETAIL_THREAD_HPP
#define CPPCMS_BOOST_ASIO_DETAIL_THREAD_HPP

#if defined(_MSC_VER) && (_MSC_VER >= 1200)
# pragma once
#endif // defined(_MSC_VER) && (_MSC_VER >= 1200)

#include <cppcms_boost/asio/detail/push_options.hpp>

#include <cppcms_boost/asio/detail/push_options.hpp>
#include <cppcms_boost/config.hpp>
#include <cppcms_boost/asio/detail/pop_options.hpp>

#if !defined(CPPCMS_BOOST_HAS_THREADS)
# include <cppcms_boost/asio/detail/null_thread.hpp>
#elif defined(CPPCMS_BOOST_WINDOWS)
# if defined(UNDER_CE)
#  include <cppcms_boost/asio/detail/wince_thread.hpp>
# else
#  include <cppcms_boost/asio/detail/win_thread.hpp>
# endif
#elif defined(CPPCMS_BOOST_HAS_PTHREADS)
# include <cppcms_boost/asio/detail/posix_thread.hpp>
#else
# error Only Windows and POSIX are supported!
#endif

namespace cppcms_boost {
namespace asio {
namespace detail {

#if !defined(CPPCMS_BOOST_HAS_THREADS)
typedef null_thread thread;
#elif defined(CPPCMS_BOOST_WINDOWS)
# if defined(UNDER_CE)
typedef wince_thread thread;
# else
typedef win_thread thread;
# endif
#elif defined(CPPCMS_BOOST_HAS_PTHREADS)
typedef posix_thread thread;
#endif

} // namespace detail
} // namespace asio
} // namespace boost

#include <cppcms_boost/asio/detail/pop_options.hpp>

#endif // BOOST_ASIO_DETAIL_THREAD_HPP
