// Copyright David Abrahams 2006. Distributed under the Boost
// Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#ifndef CPPCMS_BOOST_CONCEPT_DETAIL_CONCEPT_DEF_DWA200651_HPP
# define CPPCMS_BOOST_CONCEPT_DETAIL_CONCEPT_DEF_DWA200651_HPP
# include <cppcms_boost/preprocessor/seq/for_each_i.hpp>
# include <cppcms_boost/preprocessor/seq/enum.hpp>
# include <cppcms_boost/preprocessor/comma_if.hpp>
# include <cppcms_boost/preprocessor/cat.hpp>
#endif // BOOST_CONCEPT_DETAIL_CONCEPT_DEF_DWA200651_HPP

// BOOST_concept(SomeName, (p1)(p2)...(pN))
//
// Expands to "template <class p1, class p2, ...class pN> struct SomeName"
//
// Also defines an equivalent SomeNameConcept for backward compatibility.
// Maybe in the next release we can kill off the "Concept" suffix for good.
#if CPPCMS_BOOST_WORKAROUND(__GNUC__, <= 3)
# define CPPCMS_BOOST_concept(name, params)                                            \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct name; /* forward declaration */                                      \
                                                                                \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct CPPCMS_BOOST_PP_CAT(name,Concept)                                           \
      : name< CPPCMS_BOOST_PP_SEQ_ENUM(params) >                                       \
    {                                                                           \
        /* at least 2.96 and 3.4.3 both need this */                            \
        CPPCMS_BOOST_PP_CAT(name,Concept)();                                           \
    };                                                                          \
                                                                                \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct name                                                                
#else
# define CPPCMS_BOOST_concept(name, params)                                            \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct name; /* forward declaration */                                      \
                                                                                \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct CPPCMS_BOOST_PP_CAT(name,Concept)                                           \
      : name< CPPCMS_BOOST_PP_SEQ_ENUM(params) >                                       \
    {                                                                           \
    };                                                                          \
                                                                                \
    template < CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(CPPCMS_BOOST_CONCEPT_typename,~,params) >       \
    struct name                                                                
#endif
    
// Helper for BOOST_concept, above.
# define CPPCMS_BOOST_CONCEPT_typename(r, ignored, index, t) \
    CPPCMS_BOOST_PP_COMMA_IF(index) typename t

