// Copyright David Abrahams 2006. Distributed under the Boost
// Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#ifndef CPPCMS_BOOST_CONCEPT_USAGE_DWA2006919_HPP
# define CPPCMS_BOOST_CONCEPT_USAGE_DWA2006919_HPP

# include <cppcms_boost/concept/assert.hpp>
# include <cppcms_boost/detail/workaround.hpp>

namespace cppcms_boost { namespace concept { 

# if CPPCMS_BOOST_WORKAROUND(__GNUC__, == 2)

#  define CPPCMS_BOOST_CONCEPT_USAGE(model) ~model()

# else 

template <class Model>
struct usage_requirements
{
    ~usage_requirements() { ((Model*)0)->~Model(); }
};

#  if CPPCMS_BOOST_WORKAROUND(__GNUC__, <= 3)

#   define CPPCMS_BOOST_CONCEPT_USAGE(model)                                    \
      model(); /* at least 2.96 and 3.4.3 both need this :( */           \
      CPPCMS_BOOST_CONCEPT_ASSERT((cppcms_boost::concept::usage_requirements<model>)); \
      ~model()

#  else

#   define CPPCMS_BOOST_CONCEPT_USAGE(model)                                    \
      CPPCMS_BOOST_CONCEPT_ASSERT((cppcms_boost::concept::usage_requirements<model>)); \
      ~model()

#  endif

# endif 

}} // namespace boost::concept

#endif // BOOST_CONCEPT_USAGE_DWA2006919_HPP
