// Boost.Function library - Typeof support
//  Copyright (C) Douglas Gregor 2008
//
//  Use, modification and distribution is subject to the Boost
//  Software License, Version 1.0.  (See accompanying file
//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// For more information, see http://www.boost.org
#ifndef CPPCMS_BOOST_FUNCTION_TYPEOF_HPP
#define CPPCMS_BOOST_FUNCTION_TYPEOF_HPP
#include <cppcms_boost/function/function_fwd.hpp>
#include <cppcms_boost/typeof/typeof.hpp>

#include CPPCMS_BOOST_TYPEOF_INCREMENT_REGISTRATION_GROUP()

CPPCMS_BOOST_TYPEOF_REGISTER_TYPE(cppcms_boost::bad_function_call)

#if !defined(CPPCMS_BOOST_FUNCTION_NO_FUNCTION_TYPE_SYNTAX)
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function, (typename))
#endif

CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function0, (typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function1, (typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function2, (typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function3, 
  (typename)(typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function4, 
  (typename)(typename)(typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function5, 
  (typename)(typename)(typename)(typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function6, 
  (typename)(typename)(typename)(typename)(typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function7, 
  (typename)(typename)(typename)(typename)(typename)(typename)(typename)
  (typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function8, 
  (typename)(typename)(typename)(typename)(typename)(typename)(typename)
  (typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function9, 
  (typename)(typename)(typename)(typename)(typename)(typename)(typename)
  (typename)(typename)(typename))
CPPCMS_BOOST_TYPEOF_REGISTER_TEMPLATE(cppcms_boost::function10, 
  (typename)(typename)(typename)(typename)(typename)(typename)(typename)
  (typename)(typename)(typename)(typename))
#endif
