
#ifndef CPPCMS_BOOST_MPL_VECTOR_AUX_BEGIN_END_HPP_INCLUDED
#define CPPCMS_BOOST_MPL_VECTOR_AUX_BEGIN_END_HPP_INCLUDED

// Copyright Aleksey Gurtovoy 2000-2004
//
// Distributed under the Boost Software License, Version 1.0. 
// (See accompanying file LICENSE_1_0.txt or copy at 
// http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/mpl for documentation.

// $Id: begin_end.hpp 49267 2008-10-11 06:19:02Z agurtovoy $
// $Date: 2008-10-11 02:19:02 -0400 (Sat, 11 Oct 2008) $
// $Revision: 49267 $

#include <cppcms_boost/mpl/aux_/config/typeof.hpp>

#if defined(CPPCMS_BOOST_MPL_CFG_TYPEOF_BASED_SEQUENCES)

#   include <cppcms_boost/mpl/begin_end_fwd.hpp>
#   include <cppcms_boost/mpl/vector/aux_/iterator.hpp>
#   include <cppcms_boost/mpl/vector/aux_/tag.hpp>

namespace cppcms_boost { namespace mpl {

template<>
struct begin_impl< aux::vector_tag >
{
    template< typename Vector > struct apply
    {
        typedef v_iter<Vector,0> type;
    };
};

template<>
struct end_impl< aux::vector_tag >
{
    template< typename Vector > struct apply
    {
        typedef v_iter<Vector,Vector::size::value> type;
    };
};

}}

#endif // BOOST_MPL_CFG_TYPEOF_BASED_SEQUENCES

#endif // BOOST_MPL_VECTOR_AUX_BEGIN_END_HPP_INCLUDED
