///////////////////////////////////////////////////////////////////////////////
/// \file deprecated.hpp
/// Definition of the deprecated BOOST_PROTO_DEFINE_FUCTION_TEMPLATE and
/// BOOST_PROTO_DEFINE_VARARG_FUCTION_TEMPLATE macros
//
//  Copyright 2008 Eric Niebler. Distributed under the Boost
//  Software License, Version 1.0. (See accompanying file
//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef CPPCMS_BOOST_PROTO_DETAIL_DEPRECATED_HPP_EAN_11_25_2008
#define CPPCMS_BOOST_PROTO_DETAIL_DEPRECATED_HPP_EAN_11_25_2008

#include <cppcms_boost/proto/detail/prefix.hpp>
#include <cppcms_boost/preprocessor/cat.hpp>
#include <cppcms_boost/preprocessor/facilities/intercept.hpp>
#include <cppcms_boost/preprocessor/arithmetic/inc.hpp>
#include <cppcms_boost/preprocessor/arithmetic/dec.hpp>
#include <cppcms_boost/preprocessor/arithmetic/sub.hpp>
#include <cppcms_boost/preprocessor/punctuation/comma_if.hpp>
#include <cppcms_boost/preprocessor/control/if.hpp>
#include <cppcms_boost/preprocessor/control/expr_if.hpp>
#include <cppcms_boost/preprocessor/comparison/greater.hpp>
#include <cppcms_boost/preprocessor/tuple/elem.hpp>
#include <cppcms_boost/preprocessor/tuple/to_list.hpp>
#include <cppcms_boost/preprocessor/logical/and.hpp>
#include <cppcms_boost/preprocessor/seq/size.hpp>
#include <cppcms_boost/preprocessor/seq/enum.hpp>
#include <cppcms_boost/preprocessor/seq/seq.hpp>
#include <cppcms_boost/preprocessor/seq/to_tuple.hpp>
#include <cppcms_boost/preprocessor/seq/for_each_i.hpp>
#include <cppcms_boost/preprocessor/seq/pop_back.hpp>
#include <cppcms_boost/preprocessor/seq/push_back.hpp>
#include <cppcms_boost/preprocessor/seq/push_front.hpp>
#include <cppcms_boost/preprocessor/list/for_each_i.hpp>
#include <cppcms_boost/preprocessor/repetition/repeat.hpp>
#include <cppcms_boost/preprocessor/repetition/repeat_from_to.hpp>
#include <cppcms_boost/preprocessor/repetition/enum_binary_params.hpp>
#include <cppcms_boost/preprocessor/repetition/enum_trailing_binary_params.hpp>
#include <cppcms_boost/proto/proto_fwd.hpp>
#include <cppcms_boost/proto/detail/suffix.hpp>

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_AUX_(R, DATA, I, ELEM)                                      \
    (ELEM CPPCMS_BOOST_PP_CAT(CPPCMS_BOOST_PP_CAT(X, DATA), CPPCMS_BOOST_PP_CAT(_, I)))                              \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_YES_(R, DATA, I, ELEM)                                      \
    CPPCMS_BOOST_PP_LIST_FOR_EACH_I_R(                                                                 \
        R                                                                                       \
      , CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_AUX_                                                        \
      , I                                                                                       \
      , CPPCMS_BOOST_PP_TUPLE_TO_LIST(                                                                 \
            CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(ELEM))                                               \
          , CPPCMS_BOOST_PP_SEQ_TO_TUPLE(CPPCMS_BOOST_PP_SEQ_TAIL(ELEM))                                      \
        )                                                                                       \
    )                                                                                           \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_NO_(R, DATA, I, ELEM)                                       \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_(R, DATA, I, ELEM)                                          \
    CPPCMS_BOOST_PP_IF(                                                                                \
        CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(ELEM))                                                   \
      , CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_YES_                                                        \
      , CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_NO_                                                         \
    )(R, DATA, I, ELEM)                                                                         \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TYPE_AUX_(R, DATA, I, ELEM)                                          \
    (CPPCMS_BOOST_PP_CAT(CPPCMS_BOOST_PP_CAT(X, DATA), CPPCMS_BOOST_PP_CAT(_, I)))                                   \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_YES_(R, DATA, I, ELEM)                                      \
    <                                                                                           \
        CPPCMS_BOOST_PP_SEQ_ENUM(                                                                      \
            CPPCMS_BOOST_PP_LIST_FOR_EACH_I_R(                                                         \
                R                                                                               \
              , CPPCMS_BOOST_PROTO_VARARG_TYPE_AUX_                                                    \
              , I                                                                               \
              , CPPCMS_BOOST_PP_TUPLE_TO_LIST(                                                         \
                    CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(ELEM))                                       \
                  , CPPCMS_BOOST_PP_SEQ_TO_TUPLE(CPPCMS_BOOST_PP_SEQ_TAIL(ELEM))                              \
                )                                                                               \
            )                                                                                   \
        )                                                                                       \
    >                                                                                           \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_NO_(R, DATA, I, ELEM)                                       \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_TYPE_(R, DATA, I, ELEM)                                              \
    CPPCMS_BOOST_PP_COMMA_IF(I)                                                                        \
    CPPCMS_BOOST_PP_SEQ_HEAD(ELEM)                                                                     \
    CPPCMS_BOOST_PP_IF(                                                                                \
        CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(ELEM))                                                   \
      , CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_YES_                                                        \
      , CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_NO_                                                         \
    )(R, DATA, I, ELEM) CPPCMS_BOOST_PP_EXPR_IF(CPPCMS_BOOST_PP_GREATER(I, 1), const)                         \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_AS_EXPR_(R, DATA, I, ELEM)                                           \
    CPPCMS_BOOST_PP_EXPR_IF(                                                                           \
        CPPCMS_BOOST_PP_GREATER(I, 1)                                                                  \
      , ((                                                                                      \
            CPPCMS_BOOST_PP_SEQ_HEAD(ELEM)                                                             \
            CPPCMS_BOOST_PP_IF(                                                                        \
                CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(ELEM))                                           \
              , CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_YES_                                                \
              , CPPCMS_BOOST_PROTO_TEMPLATE_PARAMS_NO_                                                 \
            )(R, DATA, I, ELEM)()                                                               \
        ))                                                                                      \
    )                                                                                           \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_AS_CHILD_(Z, N, DATA)                                                \
    (CPPCMS_BOOST_PP_CAT(DATA, N))                                                                     \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_SEQ_PUSH_FRONT(SEQ, ELEM)                                                   \
    CPPCMS_BOOST_PP_SEQ_POP_BACK(CPPCMS_BOOST_PP_SEQ_PUSH_FRONT(CPPCMS_BOOST_PP_SEQ_PUSH_BACK(SEQ, _dummy_), ELEM))  \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_AS_PARAM_(Z, N, DATA)                                                \
    (CPPCMS_BOOST_PP_CAT(DATA, N))                                                                     \
    /**/

/// INTERNAL ONLY
///
#define CPPCMS_BOOST_PROTO_VARARG_FUN_(Z, N, DATA)                                                     \
    template<                                                                                   \
        CPPCMS_BOOST_PP_SEQ_ENUM(                                                                      \
            CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(                                                            \
                CPPCMS_BOOST_PROTO_VARARG_TEMPLATE_, ~                                                 \
              , CPPCMS_BOOST_PP_SEQ_PUSH_FRONT(                                                        \
                    CPPCMS_BOOST_PROTO_SEQ_PUSH_FRONT(                                                 \
                        CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, DATA)                                         \
                      , (CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, DATA))                                       \
                    )                                                                           \
                  , CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, DATA)                                             \
                )                                                                               \
            )                                                                                   \
            CPPCMS_BOOST_PP_REPEAT_ ## Z(N, CPPCMS_BOOST_PROTO_VARARG_AS_PARAM_, typename A)                  \
        )                                                                                       \
    >                                                                                           \
    typename cppcms_boost::proto::result_of::make_expr<                                                \
        CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(                                                                \
            CPPCMS_BOOST_PROTO_VARARG_TYPE_, ~                                                         \
          , CPPCMS_BOOST_PP_SEQ_PUSH_FRONT(                                                            \
                CPPCMS_BOOST_PROTO_SEQ_PUSH_FRONT(                                                     \
                    CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, DATA)                                             \
                  , (CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, DATA))                                           \
                )                                                                               \
              , CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, DATA)                                                 \
            )                                                                                   \
        )                                                                                       \
        CPPCMS_BOOST_PP_ENUM_TRAILING_BINARY_PARAMS_Z(Z, N, A, const & CPPCMS_BOOST_PP_INTERCEPT)             \
    >::type const                                                                               \
    CPPCMS_BOOST_PP_TUPLE_ELEM(4, 0, DATA)(CPPCMS_BOOST_PP_ENUM_BINARY_PARAMS_Z(Z, N, A, const &a))           \
    {                                                                                           \
        return cppcms_boost::proto::detail::make_expr_<                                                \
            CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(                                                            \
                CPPCMS_BOOST_PROTO_VARARG_TYPE_, ~                                                     \
              , CPPCMS_BOOST_PP_SEQ_PUSH_FRONT(                                                        \
                    CPPCMS_BOOST_PROTO_SEQ_PUSH_FRONT(                                                 \
                        CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, DATA)                                         \
                      , (CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, DATA))                                       \
                    )                                                                           \
                  , CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, DATA)                                             \
                )                                                                               \
            )                                                                                   \
            CPPCMS_BOOST_PP_ENUM_TRAILING_BINARY_PARAMS_Z(Z, N, A, const & CPPCMS_BOOST_PP_INTERCEPT)         \
        >()(                                                                                    \
            CPPCMS_BOOST_PP_SEQ_ENUM(                                                                  \
                CPPCMS_BOOST_PP_SEQ_FOR_EACH_I(                                                        \
                    CPPCMS_BOOST_PROTO_VARARG_AS_EXPR_, ~                                              \
                  , CPPCMS_BOOST_PP_SEQ_PUSH_FRONT(                                                    \
                        CPPCMS_BOOST_PROTO_SEQ_PUSH_FRONT(                                             \
                            CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, DATA)                                     \
                          , (CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, DATA))                                   \
                        )                                                                       \
                      , CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, DATA)                                         \
                    )                                                                           \
                )                                                                               \
                CPPCMS_BOOST_PP_REPEAT_ ## Z(N, CPPCMS_BOOST_PROTO_VARARG_AS_CHILD_, a)                       \
            )                                                                                   \
        );                                                                                      \
    }                                                                                           \
    /**/

/// \code
/// BOOST_PROTO_DEFINE_FUNCTION_TEMPLATE(
///     1
///   , construct
///   , boost::proto::default_domain
///   , (boost::proto::tag::function)
///   , ((op::construct)(typename)(int))
/// )
/// \endcode
#define CPPCMS_BOOST_PROTO_DEFINE_FUNCTION_TEMPLATE(ARGCOUNT, NAME, DOMAIN, TAG, BOUNDARGS)            \
    CPPCMS_BOOST_PP_REPEAT_FROM_TO(                                                                    \
        ARGCOUNT                                                                                \
      , CPPCMS_BOOST_PP_INC(ARGCOUNT)                                                                  \
      , CPPCMS_BOOST_PROTO_VARARG_FUN_                                                                 \
      , (NAME, TAG, BOUNDARGS, DOMAIN)                                                          \
    )\
    /**/

/// \code
/// BOOST_PROTO_DEFINE_VARARG_FUNCTION_TEMPLATE(
///     construct
///   , boost::proto::default_domain
///   , (boost::proto::tag::function)
///   , ((op::construct)(typename)(int))
/// )
/// \endcode
#define CPPCMS_BOOST_PROTO_DEFINE_VARARG_FUNCTION_TEMPLATE(NAME, DOMAIN, TAG, BOUNDARGS)               \
    CPPCMS_BOOST_PP_REPEAT(                                                                            \
        CPPCMS_BOOST_PP_SUB(CPPCMS_BOOST_PP_INC(CPPCMS_BOOST_PROTO_MAX_ARITY), CPPCMS_BOOST_PP_SEQ_SIZE(BOUNDARGS))         \
      , CPPCMS_BOOST_PROTO_VARARG_FUN_                                                                 \
      , (NAME, TAG, BOUNDARGS, DOMAIN)                                                          \
    )                                                                                           \
    /**/

#endif
