///////////////////////////////////////////////////////////////////////////////
// funop.hpp
// Contains definition of funop[n]\<\> class template.
//
//  Copyright 2008 Eric Niebler. Distributed under the Boost
//  Software License, Version 1.0. (See accompanying file
//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef CPPCMS_BOOST_PP_IS_ITERATING
#error Do not include this file directly
#endif

#define M0(Z, N, DATA)                                                                          \
    typename proto::result_of::as_child<CPPCMS_BOOST_PP_CAT(A, N), Domain>::type                       \
    /**/

#define M1(Z, N, DATA)                                                                          \
    proto::as_child<Domain>(CPPCMS_BOOST_PP_CAT(a, N))                                                 \
    /**/

    /// \brief A helper metafunction for computing the
    /// return type of \c proto::expr\<\>::operator().
    template<typename Expr, typename Domain CPPCMS_BOOST_PP_ENUM_TRAILING_PARAMS(CPPCMS_BOOST_PP_ITERATION(), typename A)>
    struct CPPCMS_BOOST_PP_CAT(funop, CPPCMS_BOOST_PP_ITERATION())
    {
        typedef proto::expr<
            tag::function
          , CPPCMS_BOOST_PP_CAT(list, CPPCMS_BOOST_PP_INC(CPPCMS_BOOST_PP_ITERATION()))<
                Expr &
                CPPCMS_BOOST_PP_ENUM_TRAILING(CPPCMS_BOOST_PP_ITERATION(), M0, ~)
            >
          , CPPCMS_BOOST_PP_INC(CPPCMS_BOOST_PP_ITERATION())
        > type;

        static type const call(
            Expr &e
            CPPCMS_BOOST_PP_ENUM_TRAILING_BINARY_PARAMS(CPPCMS_BOOST_PP_ITERATION(), A, &a)
        )
        {
            type that = {
                e
                CPPCMS_BOOST_PP_ENUM_TRAILING(CPPCMS_BOOST_PP_ITERATION(), M1, ~)
            };
            return that;
        }
    };

    /// \brief A helper metafunction for computing the
    /// return type of \c proto::expr\<\>::operator().
    template<typename Expr CPPCMS_BOOST_PP_ENUM_TRAILING_PARAMS(CPPCMS_BOOST_PP_ITERATION(), typename A), typename This, typename Domain>
    struct funop<Expr(CPPCMS_BOOST_PP_ENUM_PARAMS(CPPCMS_BOOST_PP_ITERATION(), A)), This, Domain>
      : CPPCMS_BOOST_PP_CAT(funop, CPPCMS_BOOST_PP_ITERATION())<
            typename detail::same_cv<Expr, This>::type
          , Domain
            CPPCMS_BOOST_PP_ENUM_TRAILING_BINARY_PARAMS(
                CPPCMS_BOOST_PP_ITERATION()
              , typename remove_reference<A
              , >::type CPPCMS_BOOST_PP_INTERCEPT
            )
        >
    {};

#undef M0
#undef M1
