// Boost.Range library
//
//  Copyright Thorsten Ottosen 2006. Use, modification and
//  distribution is subject to the Boost Software License, Version
//  1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt)
//
// For more information, see http://www.boost.org/libs/range/
//

#ifndef CPPCMS_BOOST_RANGE_DETAIL_AS_LITERAL_HPP
#define CPPCMS_BOOST_RANGE_DETAIL_AS_LITERAL_HPP

#if defined(_MSC_VER) && (_MSC_VER >= 1200)
# pragma once
#endif

#include <cppcms_boost/range/detail/detail_str.hpp>
#include <cppcms_boost/range/iterator_range.hpp>

namespace cppcms_boost
{
    template< class Range >
    inline iterator_range<CPPCMS_BOOST_DEDUCED_TYPENAME range_iterator<Range>::type> 
    as_literal( Range& r )
    {
        return ::cppcms_boost::make_iterator_range( ::cppcms_boost::range_detail::str_begin(r),
                                             ::cppcms_boost::range_detail::str_end(r) );
    }

}

#endif
