/*
 *
 * Copyright (c) 1998-2000
 * Dr John Maddock
 *
 * Use, modification and distribution are subject to the 
 * Boost Software License, Version 1.0. (See accompanying file 
 * LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 *
 */
 
 /*
  *   LOCATION:    see http://www.boost.org/libs/regex for documentation.
  *   FILE         regex.h
  *   VERSION      3.12
  *   DESCRIPTION: Declares POSIX API functions
  */

#ifndef CPPCMS_BOOST_RE_REGEX_H
#define CPPCMS_BOOST_RE_REGEX_H

#include <cppcms_boost/cregex.hpp>

/*
*  add using declarations to bring POSIX API functions into
* global scope, only if this is C++ (and not C).
*/
#ifdef __cplusplus

using cppcms_boost::regoff_t;
using cppcms_boost::regex_tA;
using cppcms_boost::regmatch_t;
using cppcms_boost::REG_BASIC;
using cppcms_boost::REG_EXTENDED;
using cppcms_boost::REG_ICASE;
using cppcms_boost::REG_NOSUB;
using cppcms_boost::REG_NEWLINE;
using cppcms_boost::REG_NOSPEC;
using cppcms_boost::REG_PEND;
using cppcms_boost::REG_DUMP;
using cppcms_boost::REG_NOCOLLATE;
using cppcms_boost::REG_ESCAPE_IN_LISTS;
using cppcms_boost::REG_NEWLINE_ALT;
using cppcms_boost::REG_PERL;
using cppcms_boost::REG_AWK;
using cppcms_boost::REG_GREP;
using cppcms_boost::REG_EGREP;
using cppcms_boost::REG_ASSERT;
using cppcms_boost::REG_INVARG;
using cppcms_boost::REG_ATOI;
using cppcms_boost::REG_ITOA;

using cppcms_boost::REG_NOTBOL;
using cppcms_boost::REG_NOTEOL;
using cppcms_boost::REG_STARTEND;

using cppcms_boost::reg_comp_flags;
using cppcms_boost::reg_exec_flags;
using cppcms_boost::regcompA;
using cppcms_boost::regerrorA;
using cppcms_boost::regexecA;
using cppcms_boost::regfreeA;

#ifndef CPPCMS_BOOST_NO_WREGEX
using cppcms_boost::regcompW;
using cppcms_boost::regerrorW;
using cppcms_boost::regexecW;
using cppcms_boost::regfreeW;
using cppcms_boost::regex_tW;
#endif

using cppcms_boost::REG_NOERROR;
using cppcms_boost::REG_NOMATCH;
using cppcms_boost::REG_BADPAT;
using cppcms_boost::REG_ECOLLATE;
using cppcms_boost::REG_ECTYPE;
using cppcms_boost::REG_EESCAPE;
using cppcms_boost::REG_ESUBREG;
using cppcms_boost::REG_EBRACK;
using cppcms_boost::REG_EPAREN;
using cppcms_boost::REG_EBRACE;
using cppcms_boost::REG_BADBR;
using cppcms_boost::REG_ERANGE;
using cppcms_boost::REG_ESPACE;
using cppcms_boost::REG_BADRPT;
using cppcms_boost::REG_EEND;
using cppcms_boost::REG_ESIZE;
using cppcms_boost::REG_ERPAREN;
using cppcms_boost::REG_EMPTY;
using cppcms_boost::REG_E_MEMORY;
using cppcms_boost::REG_E_UNKNOWN;
using cppcms_boost::reg_errcode_t;

#endif /* __cplusplus */

#endif /* BOOST_RE_REGEX_H */




