#ifndef CPPCMS_BOOST_RECURSIVE_MUTEX_WIN32_HPP
#define CPPCMS_BOOST_RECURSIVE_MUTEX_WIN32_HPP

//  recursive_mutex.hpp
//
//  (C) Copyright 2006-7 Anthony Williams 
//
//  Distributed under the Boost Software License, Version 1.0. (See
//  accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt)


#include <cppcms_boost/utility.hpp>
#include "basic_recursive_mutex.hpp"
#include <cppcms_boost/thread/exceptions.hpp>
#include <cppcms_boost/thread/locks.hpp>

#include <cppcms_boost/config/abi_prefix.hpp>

namespace cppcms_boost
{
    class recursive_mutex:
        cppcms_boost::noncopyable,
        public ::cppcms_boost::detail::basic_recursive_mutex
    {
    public:
        recursive_mutex()
        {
            ::cppcms_boost::detail::basic_recursive_mutex::initialize();
        }
        ~recursive_mutex()
        {
            ::cppcms_boost::detail::basic_recursive_mutex::destroy();
        }

        typedef unique_lock<recursive_mutex> scoped_lock;
        typedef detail::try_lock_wrapper<recursive_mutex> scoped_try_lock;
    };

    typedef recursive_mutex recursive_try_mutex;

    class recursive_timed_mutex:
        cppcms_boost::noncopyable,
        public ::cppcms_boost::detail::basic_recursive_timed_mutex
    {
    public:
        recursive_timed_mutex()
        {
            ::cppcms_boost::detail::basic_recursive_timed_mutex::initialize();
        }
        ~recursive_timed_mutex()
        {
            ::cppcms_boost::detail::basic_recursive_timed_mutex::destroy();
        }

        typedef unique_lock<recursive_timed_mutex> scoped_timed_lock;
        typedef detail::try_lock_wrapper<recursive_timed_mutex> scoped_try_lock;
        typedef scoped_timed_lock scoped_lock;
    };
}

#include <cppcms_boost/config/abi_suffix.hpp>

#endif
