
//  (C) Copyright John Maddock 2005.  
//  Use, modification and distribution are subject to the Boost Software License,
//  Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt).
//
//  See http://www.boost.org/libs/type_traits for most recent version including documentation.


#ifndef CPPCMS_BOOST_TT_IS_MEMBER_OBJECT_POINTER_HPP_INCLUDED
#define CPPCMS_BOOST_TT_IS_MEMBER_OBJECT_POINTER_HPP_INCLUDED

#include <cppcms_boost/type_traits/config.hpp>
#include <cppcms_boost/type_traits/is_member_pointer.hpp>
#include <cppcms_boost/type_traits/is_member_function_pointer.hpp>
#include <cppcms_boost/type_traits/detail/ice_and.hpp>
#include <cppcms_boost/type_traits/detail/ice_not.hpp>

// should be the last #include
#include <cppcms_boost/type_traits/detail/bool_trait_def.hpp>

namespace cppcms_boost {

namespace detail{

template <typename T>
struct is_member_object_pointer_impl
{
   CPPCMS_BOOST_STATIC_CONSTANT(
      bool, value = (::cppcms_boost::type_traits::ice_and<
         ::cppcms_boost::is_member_pointer<T>::value,
         ::cppcms_boost::type_traits::ice_not<
            ::cppcms_boost::is_member_function_pointer<T>::value
         >::value
      >::value ));
};

} // namespace detail

CPPCMS_BOOST_TT_AUX_BOOL_TRAIT_DEF1(is_member_object_pointer,T,::cppcms_boost::detail::is_member_object_pointer_impl<T>::value)

} // namespace boost

#include <cppcms_boost/type_traits/detail/bool_trait_undef.hpp>

#endif // BOOST_TT_IS_MEMBER_FUNCTION_POINTER_HPP_INCLUDED
