/*
 *
 * Copyright (c) 1998-2002
 * John Maddock
 *
 * Use, modification and distribution are subject to the 
 * Boost Software License, Version 1.0. (See accompanying file 
 * LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 *
 */

 /*
  *   LOCATION:    see http://www.boost.org for most recent version.
  *   FILE:        winstances.cpp
  *   VERSION:     see <boost/version.hpp>
  *   DESCRIPTION: regex unsigned short template instances (MSVC only).
  */

#define CPPCMS_BOOST_REGEX_SOURCE

#include <cppcms_boost/detail/workaround.hpp>
#include <memory>
#include <string>

#if defined(_DLL_CPPLIB) && !defined(_M_CEE_PURE) && defined(_NATIVE_WCHAR_T_DEFINED) \
   && !(defined(__SGI_STL_PORT) || defined(_STLPORT_VERSION) || defined(__STD_RWCOMPILER_H__) || defined(_RWSTD_VER))\
   && CPPCMS_BOOST_WORKAROUND(CPPCMS_BOOST_MSVC, <1600)
//
// This is a horrible workaround, but without declaring these symbols extern we get
// duplicate symbol errors when linking if the application is built without
// /Zc:wchar_t
//
#ifdef _CRTIMP2_PURE
#  define CPPCMS_BOOST_REGEX_STDLIB_DECL _CRTIMP2_PURE
#else
#  define CPPCMS_BOOST_REGEX_STDLIB_DECL _CRTIMP2
#endif

namespace std{

#if CPPCMS_BOOST_WORKAROUND(CPPCMS_BOOST_MSVC, >= 1400)
template class CPPCMS_BOOST_REGEX_STDLIB_DECL allocator<unsigned short>;
template class CPPCMS_BOOST_REGEX_STDLIB_DECL _String_val<unsigned short, allocator<unsigned short> >;
template class CPPCMS_BOOST_REGEX_STDLIB_DECL basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >;
#endif

#if CPPCMS_BOOST_WORKAROUND(CPPCMS_BOOST_MSVC, > 1300) && CPPCMS_BOOST_WORKAROUND(CPPCMS_BOOST_MSVC, CPPCMS_BOOST_TESTED_AT(1400))
template<> CPPCMS_BOOST_REGEX_STDLIB_DECL std::size_t __cdecl char_traits<unsigned short>::length(unsigned short const*);
#endif

template CPPCMS_BOOST_REGEX_STDLIB_DECL bool __cdecl operator==(
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&,
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&);
template CPPCMS_BOOST_REGEX_STDLIB_DECL bool __cdecl operator==(
   const unsigned short *,
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&);
template CPPCMS_BOOST_REGEX_STDLIB_DECL bool __cdecl operator==(
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&,
   const unsigned short *);
template CPPCMS_BOOST_REGEX_STDLIB_DECL bool __cdecl operator<(
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&,
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&);
template CPPCMS_BOOST_REGEX_STDLIB_DECL bool __cdecl operator>(
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&,
   const basic_string<unsigned short, char_traits<unsigned short>, allocator<unsigned short> >&);
}
#endif

#include <cppcms_boost/regex/config.hpp>

#if !defined(CPPCMS_BOOST_NO_WREGEX) && defined(CPPCMS_BOOST_REGEX_HAS_OTHER_WCHAR_T) && !defined(CPPCMS_BOOST_REGEX_NO_EXTERNAL_TEMPLATES)
#define CPPCMS_BOOST_REGEX_US_INSTANTIATE

#include <cppcms_boost/regex.hpp>

#endif


